/*********************************************************************
*
*   HEADER NAME:
*       CCdtChatDlg.h
*
* Copyright 2014 by Garmin Ltd. or its subsidiaries.
*---------------------------------------------------------------------
* $NoKeywords$
*********************************************************************/
#pragma once

#include "CWebBrowser2.h"
#include "FmiApplicationLayer.h"
#include "CWndEventListener.h"

#if( CDT_SUPPORT )

// CCdtChatDlg dialog

//----------------------------------------------------------------------
//! \brief Browser-based container chatting with CDT-enabled device/client
//! \details
//----------------------------------------------------------------------
class CCdtChatDlg : public CDialog, public CWndEventListener
{
    DECLARE_DYNAMIC(CCdtChatDlg)

public:
    CCdtChatDlg(
        CWnd* pParent,
        FmiApplicationLayer & aCom
    );
    virtual ~CCdtChatDlg();

// Dialog Data
    enum { IDD = IDD_CDT_CHAT };

protected:
    virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

    DECLARE_MESSAGE_MAP()

    BOOL OnInitDialog();
    afx_msg void OnSize
        (
        UINT aType,
        int  aClientWidth,
        int  aClientHeight
        );

    void updateSize();

    afx_msg LRESULT OnCDTPacketReceived( WPARAM, LPARAM );

    virtual afx_msg void OnOK();

    CWebBrowser2 mBrowser;

    CEdit mInputField;

    int mPadding;
    int mInputHeight;

    //! Reference to the FMI communication controller
    FmiApplicationLayer& mCom;

};

#endif