/*********************************************************************
*
*   HEADER NAME:
*       CDashcam.h
*
* Copyright 2015 by Garmin Ltd. or its subsidiaries.
*---------------------------------------------------------------------
* $NoKeywords$
*********************************************************************/
#include "FmiApplicationLayer.h"
#include "CWndEventListener.h"

#if( FMI_SUPPORT_A622 )

// CDashcam dialog

//----------------------------------------------------------------------
//! \brief Browser-based container for listing the Dashcam library
//! \details
//----------------------------------------------------------------------
class CDashcamDlg : public CDialog, public CWndEventListener
{
    DECLARE_DYNAMIC( CDashcamDlg )

public:
    CDashcamDlg(
        CWnd* pParent,
        FmiApplicationLayer & aCom
    );
    virtual ~CDashcamDlg();

// Dialog Data
    enum { IDD = IDD_DASHCAM };

protected:
    virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

    DECLARE_MESSAGE_MAP()

    void PostNcDestroy();
    afx_msg LRESULT CDashcamDlg::OnDashcamLockReceipt( WPARAM, LPARAM );
    afx_msg LRESULT CDashcamDlg::OnDashcamConfigReceipt( WPARAM, LPARAM );
    afx_msg LRESULT CDashcamDlg::OnDashcamGetSettingsResponse( WPARAM, LPARAM );

    void OnBnClickedSet();
    void OnRefreshSettings();
    void OnClose();
    void OnReevaluate();
    void OnBnClickedSelectAll();
    void OnReevaluateLock();
    void OnBnClickedSetLock();
    void postFailure( uint8 );

    //! Reference to the FMI communication controller
    FmiApplicationLayer& mCom;

    BOOL OnInitDialog();

    int mLockDashcam;
    int mLockAssist;
    int mForwardCollision;
    int mCollisionSensitivity;
    int mLaneDeparture;
    int mRecordOnStartup;
    int mIncidentDetection;
    int mRecordAudio;
    int mDataOverlayDateTime;
    int mDataOverlayLocationSpeed;
    int mVideoResolution;
    int mRecordAfterPowerLoss;
    BOOL mSelectAll;
    BOOL mSendCollisionWarning;
    BOOL mSendCollisionSensitivity;
    BOOL mSendLaneDeparture;
    BOOL mSendRecordOnStartup;
    BOOL mSendIncidentDetection;
    BOOL mSendRecordAudio;
    BOOL mSendDataOverlayDateTime;
    BOOL mSendDataOverlayLocationSpeed;
    BOOL mSendVideoResolution;
    BOOL mSendRecordAfterPowerLoss;
};

#endif