/*********************************************************************
*
*   HEADER NAME:
*       CDashcamNtfctnDlg.h
*
* Copyright 2015 by Garmin Ltd. or its subsidiaries.
*---------------------------------------------------------------------
* $NoKeywords$
*********************************************************************/
#include "FmiApplicationLayer.h"
#include "CWndEventListener.h"

#if( FMI_SUPPORT_A622 )

// CDashcamNtfctn dialog

//----------------------------------------------------------------------
//! \brief Browser-based container for listing the Dashcam library
//! \details
//----------------------------------------------------------------------
class CDashcamNtfctnDlg : public CDialog, public CWndEventListener
{
    DECLARE_DYNAMIC( CDashcamNtfctnDlg )

public:
    CDashcamNtfctnDlg(
        CWnd* pParent,
        FmiApplicationLayer & aCom
    );
    virtual ~CDashcamNtfctnDlg();

// Dialog Data
    enum { IDD = IDD_DASHCAM_NTFCTN };

protected:
    virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

    DECLARE_MESSAGE_MAP()

    void PostNcDestroy();
    afx_msg LRESULT CDashcamNtfctnDlg::OnDashcamSetNtfctnReceipt( WPARAM, LPARAM );
    afx_msg LRESULT CDashcamNtfctnDlg::OnGetNtfctnSettingsResponse( WPARAM, LPARAM );

    void OnBnClickedSet();
    void OnRefreshNtfctnSettings();
    void OnClose();
    void OnReevaluate();

    //! Reference to the FMI communication controller
    FmiApplicationLayer& mCom;

    BOOL OnInitDialog();

    int mForwardCollisionNtfctn;
    int mLaneDepartureNtfctn;
    int mIncidentDetectionNtfctn;
};

#endif