/*********************************************************************
*
*   HEADER NAME:
*       CDashcamNtfctnFromClient.h
*
*   Copyright 2015 by Garmin Ltd. or its subsidiaries.
*---------------------------------------------------------------------
* $NoKeywords$
*********************************************************************/
#pragma once

#include "EventId.h"
#include "FmiApplicationLayer.h"

#if( FMI_SUPPORT_A622 )

//----------------------------------------------------------------------
//! \brief Modal pop up dialog displaying a client to server dashcam
//!     notification.
//! \details Displays the last client to server dashcam notification in
//!     a dialog box.  The notification Orig time, Lat, Lon, and type
//!     are retrieved from the event passed to the constructor.
//! \since Protocol A622
//----------------------------------------------------------------------
class CDashcamNtfctnFromClient : public CDialog
{
    DECLARE_DYNAMIC( CDashcamNtfctnFromClient )
    DECLARE_MESSAGE_MAP()

public:
    CDashcamNtfctnFromClient
        (
        CWnd                                            * aParent,
        FmiApplicationLayer                             & aCom,
        const fmi_dashcam_ntfctn_req_data_type          & aEvent
        );

    CDashcamNtfctnFromClient
        (
        CWnd                                            * aParent,
        FmiApplicationLayer                             & aCom,
        const fmi_dashcam_ntfctn_incident_req_data_type & aEvent
        );

    virtual ~CDashcamNtfctnFromClient();

protected:
    virtual void DoDataExchange
        (
        CDataExchange * aDataExchange
        );

    void init
        (
        time_type           origination_time,
        sc_position_type    scposn,
        uint8               ntfctn_type
        );

    //! Reference to the FMI communication controller
    FmiApplicationLayer & mCom;

    CString mOriginationTime;
    CString mLongitude;
    CString mLatitude;
    CString mType;
    CString mIncidentFilename;
};

#endif
