/*********************************************************************
*
*   HEADER NAME:
*       CEtaModeDlg.h
*
*   Copyright 2008-2016 by Garmin Ltd. or its subsidiaries.
*---------------------------------------------------------------------
* $NoKeywords$
*********************************************************************/
#ifndef CEtaModeDlg_H
#define CEtaModeDlg_H

#include "FmiApplicationLayer.h"

//----------------------------------------------------------------------
//! \brief Modal dialog allowing the user to select an ETA mode
//!     for the device to operate in.
//! \since Protocol A623
//----------------------------------------------------------------------
class CEtaModeDlg : public CDialog
{
    DECLARE_DYNAMIC( CEtaModeDlg )
    DECLARE_MESSAGE_MAP()

public:
    CEtaModeDlg
        (
        CWnd                * aParent,
        FmiApplicationLayer & aCom
        );
    virtual ~CEtaModeDlg();

    typedef CString mode_type;

private:
    virtual void DoDataExchange
        (
        CDataExchange* aDataExchange
        );

    BOOL OnInitDialog();
    afx_msg void OnBnClickedSend();

    //! Reference to the FMI communication controller
    FmiApplicationLayer& mCom;

    //! Mode to be transferred, as specified by the user
    FMI_eta_mode_type mMode;

    };

#endif