/*********************************************************************
*
*   MODULE NAME:
*       CTimeOfDayPickerDlg.cpp
*
* Copyright 2014 by Garmin Ltd. or its subsidiaries.
*---------------------------------------------------------------------
* $NoKeywords$
*********************************************************************/

#include "stdafx.h"
#include "CTimeOfDayPickerDlg.h"

#if( FMI_SUPPORT_A620 )

// CTimeOfDayPickerDlg dialog

IMPLEMENT_DYNAMIC(CTimeOfDayPickerDlg, CDialog)

UINT CTimeOfDayPickerDlg::CaptureSetting(
    CWnd* pParent,
    UINT titleStringId,
    UINT valueLabelStringId,
    COleDateTime & value
    )
{
    CTimeOfDayPickerDlg dlg( pParent );
    dlg.mTitleStringId = titleStringId;
    dlg.mValueLabelStringId = valueLabelStringId;
    dlg.mValue = value;
    if( IDOK == dlg.DoModal() )
    {
        value = dlg.mValue;
        return IDOK;
    }
    return IDCANCEL;
}

//----------------------------------------------------------------------
//! \brief Constructor
//! \param aParent The parent window
//! \param aCom Reference to the FMI communication controller
//----------------------------------------------------------------------
CTimeOfDayPickerDlg::CTimeOfDayPickerDlg(
    CWnd* pParent
    )
    : CDialog(CTimeOfDayPickerDlg::IDD, pParent)
    , mValue(COleDateTime::GetCurrentTime())
    {

}

CTimeOfDayPickerDlg::~CTimeOfDayPickerDlg()
{
}

void CTimeOfDayPickerDlg::DoDataExchange(CDataExchange* pDX)
{
CDialog::DoDataExchange(pDX);
DDX_DateTimeCtrl(pDX, IDC_TIME_OF_DAY, mValue);
    }


BEGIN_MESSAGE_MAP(CTimeOfDayPickerDlg, CDialog)
END_MESSAGE_MAP()

// CTimeOfDayPickerDlg message handlers

//----------------------------------------------------------------------
//! \brief Initialize the dialog
//! \details This function is called when the window is created. It
//!     sets up the parent, so it can get info from and send a message
//!     to FmiApplicationLayer.
//! \return TRUE, since this function does not set focus to a control
//----------------------------------------------------------------------
BOOL CTimeOfDayPickerDlg::OnInitDialog()
{
    CDialog::OnInitDialog();

    //initialize controls
    CString title;
    title.LoadString( mTitleStringId );
    SetWindowText( title );

    CString label;
    label.LoadString( mValueLabelStringId );
    GetDlgItem( IDC_HOS_SETTING_VALUE_LABEL )->SetWindowText( label );

    return TRUE;
}

#endif
