/*********************************************************************
*
*   HEADER NAME:
*       CTimeOfDayPickerDlg.h
*
* Copyright 2014 by Garmin Ltd. or its subsidiaries.
*---------------------------------------------------------------------
* $NoKeywords$
*********************************************************************/
#pragma once

#include "FmiApplicationLayer.h"

#if( FMI_SUPPORT_A615 )

//----------------------------------------------------------------------
//! \brief Form for individually capturing time of day
//----------------------------------------------------------------------
class CTimeOfDayPickerDlg : public CDialog
{
    DECLARE_DYNAMIC(CTimeOfDayPickerDlg)

public:
    static UINT CaptureSetting(
        CWnd* pParent,
        UINT titleStringId,
        UINT valueLabelStringId,
        COleDateTime & value
    );

    virtual ~CTimeOfDayPickerDlg();

// Dialog Data
    enum { IDD = IDD_TIME_OF_DAY_PICKER };

protected:
    CTimeOfDayPickerDlg(
        CWnd* pParent
    );   // standard constructor
    virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

    DECLARE_MESSAGE_MAP()

    BOOL OnInitDialog();

    //! Control value representing the selected value
    COleDateTime mValue;

    //! Resource ID for the window title
    UINT mTitleStringId;

    //! Resource ID for the value field label
    UINT mValueLabelStringId;

    };

#endif