/*********************************************************************
*
*   MODULE NAME:
*       AppMain.cpp
*
* Copyright 2008-2016 by Garmin Ltd. or its subsidiaries.
*---------------------------------------------------------------------
* $NoKeywords$
*********************************************************************/

#include "FileConverter.h"

//--------------------------------------------------------------------
//! \brief Main entry point for the FleetFileUtility
//! \param argc Argument count
//! \param argv Argument list
//! \return 0 if successful
//--------------------------------------------------------------------
int wmain( int argc, wchar_t* argv[] )
{
    locale::global(locale(""));

    wstring executable(argv[0]);
    wstring usage( L"\nInsufficient arguments.\n Usage: " + executable
        + L" conversion_type src_file dst_file [-I stop_ID] [-R route_name]"
        L" (-S src_coords | -D dst_coords)\n Use --help for more details." );
    if( argc < 2 )
    {
        wcout << usage << endl;
        return ERROR;
    }

    int result;
    CFileConverter fc;

    result = fc.ParseCommandLine( argc, argv );
    if( result == SUCCESS )
    {
        switch ( fc.mOpt )
        {
            case PSRtoCSV:
                result = fc.ConvertPSRtoCSV();
                break;
            case CSVtoPSR:
                result = fc.ConvertCSVtoPSR();
                break;
            case GPXtoPSR:
                result = fc.ConvertGPXtoPSR();
                break;
            default:
                result = ERROR;
                break;
        }
    }
    if( result == SUCCESS )
    {
        wcout << L"File Conversion Successful!" << endl;
    }

    return result;
}