/*********************************************************************
*
*   MODULE NAME:
*       FileConverter.h
*
* Copyright 2008-2016 by Garmin Ltd. or its subsidiaries.
*---------------------------------------------------------------------
* $NoKeywords$
*********************************************************************/
#pragma once

#include <boost/program_options.hpp>
#include <boost/locale.hpp>
#include <iostream>

#include "Utility.h"

using namespace std;

enum conversion_type_type
{
    PSRtoCSV = 1,
    CSVtoPSR,
    GPXtoPSR
};

//----------------------------------------------------------------------
//! \brief Class declaration for the CFileConverter class
//----------------------------------------------------------------------
class CFileConverter
{
public:

    CFileConverter();

    int ParseCommandLine( int argc, wchar_t* argv[] );
    int ConvertPSRtoCSV( );
    int ConvertCSVtoPSR( );
    int ConvertGPXtoPSR( );
    void DeleteDstFile( );
    void WritePSRHeader( ofstream &psrFile );

    //! Conversion option
    uint32 mOpt;

    //! Full path to the source file
    wstring mSrcFilePath;

    //! Full path to the destination file
    wstring mDstFilePath;

    //! Unique stop ID
    uint32 mStopId;

    //! Route name
    wstring mRouteName;

    //! Format of the coordinates of either the src or dst file
    //!   depending on the conversion option.
    short  mCoordsFormat;
};