/*********************************************************************
*
*   HEADER NAME:
*       TcpIpPort.h
*
*   Copyright 2016 by Garmin Ltd. or its subsidiaries.
*---------------------------------------------------------------------
* $NoKeywords$
*********************************************************************/
#ifndef TcpIpPort_H
#define TcpIpPort_H

class SerialPort;

#include <list>
#include <afxsock.h>

#include "stdafx.h"
#include "garmin_types.h"
#include "TimerListener.h"
#include "PhysicalLayer.h"
#include "SerialPort.h"

class LinkLayer;

//----------------------------------------------------------------------
//! \brief Physical layer implementation for a serial port
//----------------------------------------------------------------------
class TcpIpPort : protected SerialPort
{
public:
    static bool initTcpPort();

    virtual bool setBaudRate
        (
        uint32 aBaudRate
        );

    virtual uint32 getBaudRate() const;

    virtual const CString& getPortName() const;

    virtual bool isOpen() const;

    virtual bool tx
        (
        uint8 * aData,
        uint16  aSize
        );

protected:
    TcpIpPort();
    virtual ~TcpIpPort();

    bool init();

    virtual void pumpRx();

    virtual void close();

private:

    //! Display name of the serial port being used for communication
    CString                 mPortName;

    //! The last successfully applied baud rate
    uint32                  mBaudRate;

    CSocket                 clientSocket;

    bool                    socketIsOpen;
};

#endif
