/*********************************************************************
*
*   MODULE NAME:
*       UTL_crc.h - CRC Routines
*
*   DESCRIPTION:
*
*   PUBLIC PROCEDURES:
*       Name                        Title
*       -----------------------     --------------------------------------
*       UTL_calc_crc32              Calculate 32-bit CRC
*
*   PRIVATE PROCEDURES:
*       Name                        Title
*       -----------------------     --------------------------------------
*       UTL_accumulate_crc32        Accumulate 32-bit CRC Calculation
*       UTL_complete_crc32          Complete 32-bit CRC Calculation
*
*   LOCAL PROCEDURES:
*       Name                        Title
*       -----------------------     --------------------------------------
*
*   NOTES:
*
*   Copyright 2008 by Garmin Ltd. or its subsidiaries.
*********************************************************************/

/*--------------------------------------------------------------------
                           GENERAL INCLUDES
--------------------------------------------------------------------*/

/*--------------------------------------------------------------------
                          LITERAL CONSTANTS
--------------------------------------------------------------------*/

/*--------------------------------------------------------------------
                                 TYPES
--------------------------------------------------------------------*/

/*--------------------------------------------------------------------
                           PROJECT INCLUDES
--------------------------------------------------------------------*/
#include "garmin_types.h"
/*--------------------------------------------------------------------
                           MEMORY CONSTANTS
--------------------------------------------------------------------*/

/*--------------------------------------------------------------------
                              VARIABLES
--------------------------------------------------------------------*/

/*--------------------------------------------------------------------
                                MACROS
--------------------------------------------------------------------*/

/*--------------------------------------------------------------------
                              PROCEDURES
--------------------------------------------------------------------*/

uint32 UTL_calc_crc32
    (
    uint8   const * const data,
    uint32          const size,
    uint32          const initial_value = 0
    );

uint32 UTL_accumulate_crc32
    (
    uint8   const * const data,
    uint32          const size,
    uint32          const accumulative_value
    );

uint32 UTL_complete_crc32
    (
    uint32          const actual_crc
    );
